<script lang="ts">
import {
  h,
  Transition,
  type ConcreteComponent,
  type FunctionalComponent,
} from 'vue'

const enterFromLeaveTo = 'height-0 opacity-0'
const enterLeaveActive =
  'overflow-hidden opacity-100 motion-safe:transition-[height,opacity] motion-safe:duration-200'

const options = {
  name: 'expand',

  class:
    '*:opacity-100 *:will-change-[height,opacity] *:[backface-visibility:hidden] *:[transform:translateZ(0)] *:[perspective:1000px]',
  enterFromClass: enterFromLeaveTo,
  leaveToClass: enterFromLeaveTo,
  enterActiveClass: enterLeaveActive,
  leaveActiveClass: enterLeaveActive,

  onAfterEnter(element: HTMLElement) {
    // eslint-disable-next-line no-param-reassign
    element.style.height = 'auto'
  },

  onEnter(element: HTMLElement) {
    const { width } = getComputedStyle(element)

    /* eslint-disable no-param-reassign */
    element.style.width = width
    element.style.position = 'absolute'
    element.style.visibility = 'hidden'
    element.style.height = 'auto'
    /* eslint-enable */

    const { height } = getComputedStyle(element)

    /* eslint-disable no-param-reassign */
    element.style.width = ''
    element.style.position = ''
    element.style.visibility = ''
    element.style.height = '0'
    /* eslint-enable */

    // Force repaint to make sure the
    // animation is triggered correctly.
    // eslint-disable-next-line no-unused-expressions
    getComputedStyle(element).height

    requestAnimationFrame(() => {
      // eslint-disable-next-line no-param-reassign
      element.style.height = height
    })
  },

  onLeave(element: HTMLElement) {
    const { height } = getComputedStyle(element)

    // eslint-disable-next-line no-param-reassign
    element.style.height = height

    // Force repaint to make sure the
    // animation is triggered correctly.
    // eslint-disable-next-line no-unused-expressions
    getComputedStyle(element).height

    requestAnimationFrame(() => {
      // eslint-disable-next-line no-param-reassign
      element.style.height = '0'
    })
  },
}

export const UiTransitionExpand: FunctionalComponent = (props, context) => {
  return h<ConcreteComponent>(
    Transition,
    { ...context.attrs, ...props, ...options },
    context.slots,
  )
}

export default UiTransitionExpand
</script>
